# Copyright 2015 MongoDB, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

import logging

logger = logging.getLogger('giza.content.tocs.inheritance')

from giza.core.inheritance import InheritableContentError, DataContentBase, DataCache
from giza.content.tocs.models import TocData

class TocError(InheritableContentError): pass

class TocFile(DataContentBase):
    content_class = TocData

    def ordered_items(self):
        return [
            self.fetch(ref)
            for ref in self.ordering
        ]


    def is_spec(self):
        for content_item in self.content.values():
            if content_item.source is None:
                continue
            else:
                return True

        return False

class TocDataCache(DataCache):
    content_class = TocFile
